 using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LotusCraft.AutoCast
{
	public class SpellAutoCast<IHolder> : thrts.AutoCastParameter<IHolder>
	{
		public SpellAutoCast(thrts.SpellParameter<IHolder> spell, int interval, Func<IHolder, bool> castAction,bool defaultEnable = false)
		{
			this.Name = spell.Name;
			this.CastInterval = interval;
			this.CastAction = castAction;
			this.DefaultAutoCastEnable = defaultEnable;
			this.IsSpellAutocast = true;
			this.ButtonPosX = spell.ButtonPosX;
			this.ButtonPosY = spell.ButtonPosY;
		}
	}
}
