﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;

namespace LotusCraft.Bullet
{
	public class Low02_Gun : thrts.BulletParameter
	{
		public Low02_Gun()
		{
			Type = BulletType.LongRange;
			this.Attack = 18;
			Speed = BulletUtls.NormalSpeed * BasisSpeed;

			MaxRange = 6 * 32;

			AttackDelay = (int)(0.5f * 30);
			AttackRigor = (int)(0.3f * 30);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;


			TextureAnimation = new TextureAnimation();
			TextureAnimation.Path = "LotusCraft/Image/Bullet/bullet";
			TextureAnimation.Width = 16;
			TextureAnimation.Height = 16;
			TextureAnimation.Center.X = 8;
			TextureAnimation.Center.Y = 8;
			TextureAnimation.CenterPosition = CenterPosition.MiddleMiddle;
			TextureAnimation.FrameCount = 1;
			TextureAnimation.FrameTime = 1;
			TextureAnimation.HasDirection = true;
			TextureAnimation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			TextureAnimation.Count.X = 4;
			TextureAnimation.Count.Y = 8;
		}
	}
}
