﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace thrts.Unit.Button
{
	//public class NormalButton : thrts.ButtonParameter<thrts.IBuilding>
	//{
	//	public NormalButton()
	//	{
	//		Position = Tuple.Create(ButtonPosition._1, ButtonPosition._1);
	//		ButtonImagePath = "LotusCraft/Image/Button/Normal";
	//		MouseOverText =	new System.Collections.ObjectModel.ReadOnlyCollection<ColorTextLine>
	//		(
	//			new[]
	//			{
	//				new ColorTextLine
	//					(
	//						new ColorText("ノーマルへアップグレード")
	//					)
	//			}
	//		);
	//		Kind = ButtonKind.Upgrade;
	//		UpgradeButtonEvent = () => 0x02;
	//		Page = ButtonPage.DefaultPage;
	//	}
	//}
	//public class HardButton : thrts.ButtonParameter<thrts.IBuilding>
	//{
	//	public HardButton()
	//	{
	//		Position = Tuple.Create(ButtonPosition._1, ButtonPosition._1);
	//		ButtonImagePath = "LotusCraft/Image/Button/Hard";
	//		MouseOverText = new System.Collections.ObjectModel.ReadOnlyCollection<ColorTextLine>
	//		(
	//			new[]
	//			{
	//				new ColorTextLine
	//					(
	//						new ColorText("ハードへアップグレード")
	//					)
	//			}
	//		);
	//		Kind = ButtonKind.Upgrade;
	//		UpgradeButtonEvent = () => 0x04;
	//		Page = ButtonPage.DefaultPage;
	//	}
	//}
	//public class LunaticButton : thrts.ButtonParameter<thrts.IBuilding>
	//{
	//	public LunaticButton()
	//	{
	//		Position = Tuple.Create(ButtonPosition._1, ButtonPosition._1);
	//		ButtonImagePath = "LotusCraft/Image/Button/Lunatic";
	//		MouseOverText = new System.Collections.ObjectModel.ReadOnlyCollection<ColorTextLine>
	//		(
	//			new[]
	//			{
	//				new ColorTextLine
	//					(
	//						new ColorText("ルナティックへアップグレード")
	//					)
	//			}
	//		);
	//		Kind = ButtonKind.Upgrade;
	//		UpgradeButtonEvent = () => 0x08;
	//		Page = ButtonPage.DefaultPage;
	//	}
	//}
	public class CreateYukariEasy : thrts.ButtonParameter<thrts.IBuilding>
	{
		public CreateYukariEasy()
		{
			Position = Tuple.Create(ButtonPosition._3, ButtonPosition._0);
			ButtonImagePath = "LotusCraft/Image/Button/yukari_e";
			MouseOverTextFunc = _ =>
			(
				new[]
				{
					new ColorTextLine
						(
							new ColorText("E紫作成")
						)
				}
			);
			Kind = ButtonKind.CreateUnit;
			CreateUnitEvent = (building, isAppend) => building.AddCreationOfUnitQueue("hoge", "thrts.Unit.Test");
		}
	}
	public class CreateYukariNormal : thrts.ButtonParameter<thrts.IBuilding>
	{
		public CreateYukariNormal()
		{
			Position = Tuple.Create(ButtonPosition._3, ButtonPosition._0);
			ButtonImagePath = "LotusCraft/Image/Button/yukari_n";
			MouseOverTextFunc = _ =>
			(
				new[]
				{
					new ColorTextLine
						(
							new ColorText("N紫作成")
						)
				}
			);
			Kind = ButtonKind.CreateUnit;
			CreateUnitEvent = (building, isAppend) => { };
		}
	}
	public class CreateYukariHard : thrts.ButtonParameter<thrts.IBuilding>
	{
		public CreateYukariHard()
		{
			Position = Tuple.Create(ButtonPosition._3, ButtonPosition._0);
			ButtonImagePath = "LotusCraft/Image/Button/yukari_h";
			MouseOverTextFunc = _ =>
			(
				new[]
				{
					new ColorTextLine
						(
							new ColorText("H紫作成")
						)
				}
			);
			Kind = ButtonKind.CreateUnit;
			CreateUnitEvent = (building, isAppend) => { };
		}
	}
	public class CreateYukariLunatic : thrts.ButtonParameter<thrts.IBuilding>
	{
		public CreateYukariLunatic()
		{
			Position = Tuple.Create(ButtonPosition._3, ButtonPosition._0);
			ButtonImagePath = "LotusCraft/Image/Button/yukari_l";
			MouseOverTextFunc = _ =>
			(
				new[]
				{
					new ColorTextLine
						(
							new ColorText("L紫作成")
						)
				}
			);
			Kind = ButtonKind.CreateUnit;
			CreateUnitEvent = (building, isAppend) => { };
		}
	}
	public class UnStationButton : thrts.ButtonParameter<thrts.IBuilding>
	{
		public UnStationButton()
		{
			Position = Tuple.Create(ButtonPosition._4, ButtonPosition._1);
			ButtonImagePath = "LotusCraft/Image/Button/UnStation";
			MouseOverTextFunc = _ =>
			(
				new[]
				{
					new ColorTextLine
						(
							new ColorText("駐留解除")
						)
				}
			);
			Kind = ButtonKind.Normal;
			NormalButtonEvent = (unit, isAppend) => { };
		}
	}
	public class BuildingButton : thrts.ButtonParameter<thrts.IUnit>
	{
		public BuildingButton()
		{
			Position = Tuple.Create(ButtonPosition._0, ButtonPosition._2);
			ButtonImagePath = "LotusCraft/Image/Button/Building";
			MouseOverTextFunc = _ =>
			(
				new[]
				{
					new ColorTextLine
						(
							new ColorText("建築")
						)
				}
			);
			Kind = ButtonKind.CreateBuilding;
			CreateBuildingEvent = (unit, isAppend) => "LotusCraft.Building.White.HomeBase";
		}
	}

	public class AttackStateButton : thrts.ButtonParameter<thrts.IUnit>
	{
		public AttackStateButton()
		{
			Position = Tuple.Create(ButtonPosition._4, ButtonPosition._0);
			ButtonImagePath = "LotusCraft/Image/Button/AttackState";
			MouseOverTextFunc = _ =>
			(
				new[]
				{
					new ColorTextLine
						(
							new ColorText("敵攻撃")
						)
				}
			);
			Kind = ButtonKind.Normal;
			NormalButtonEvent = (unit, isAppend) => { };
		}
	}
	public class HoldPositionButton : thrts.ButtonParameter<thrts.IUnit>
	{
		public HoldPositionButton()
		{
			Position = Tuple.Create(ButtonPosition._2, ButtonPosition._0);
			ButtonImagePath = "LotusCraft/Image/Button/HoldPositionState";
			MouseOverTextFunc = _ =>
			(
				new[]
				{
					new ColorTextLine
						(
							new ColorText("待機")
						)
				}
			);
			Kind = ButtonKind.Normal;
			NormalButtonEvent = (unit, isAppend) => { };
		}
	}

	public class StationButton : thrts.ButtonParameter<thrts.IUnit>
	{
		public StationButton()
		{
			Position = Tuple.Create(ButtonPosition._4, ButtonPosition._1);
			ButtonImagePath = "LotusCraft/Image/Button/Station";
			MouseOverTextFunc = _ =>
			(
				new[]
				{
					new ColorTextLine
						(
							new ColorText("駐留")
						)
				}
			);
			Kind = ButtonKind.SelectFriend;
			SelectUnitBuildingButtonEvent = (unit, units, buildings, isAppend) => { };
		}
	}

	public class SanaeCutinButton : thrts.ButtonParameter<thrts.IUnit>
	{
		public SanaeCutinButton()
		{
			Position = Tuple.Create(ButtonPosition._1, ButtonPosition._1);
			ButtonImagePath = "LotusCraft/Image/Button/AttackState";
			MouseOverTextFunc = _ =>
			(
				new[]
				{
					new ColorTextLine
						(
							new ColorText("カットイン")
						)
				}
			);
			Kind = ButtonKind.Normal;
			NormalButtonEvent = (unit, isAppend) => unit.ShowCutin();
		}
	}
}
