﻿#if !_TRIAL
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using LotusCraft.Unit.Black;
using LotusCraft.Unit.Black.Unique;
using LotusCraft.Building.Black;
using LotusCraft.Effect.Black;

namespace LotusCraft.COM
{
	public class Black : thrts.COM
	{
		int time = -1;
		int farmercount = 3;
		int homecount = 0;
		int barrakscount = 0;
		int blacksmithcount = 0;
		int factoryscount = 0;
		int super1count = 0;
		int super2count = 0;
		int super3count = 0;
		int airportcount = 0;
		int produce0count = 0;
		int produce1count = 0;
		int low01count = 0;
		int low02count = 0;
		int low03count = 0;
		int starcount = 0;
		int orincount = 0;
		int satoricount = 0;
		int NeedResource = 0;
		int threshold = 820;
		float LastProgress = -1;
		bool instant = true;
		int uniquestart = 60;
		int stoptime = 0;
		bool toGreen = false;
		bool StopForUnique = false;
		thrts.IBuilding LastBuilding = null;
		thrts.IBuilding FirstHome = null;
		Dictionary<string, bool> flag= new Dictionary<string,bool>();

		IEnumerable<thrts.IUnit> uniques;

		thrts.Vector3D InitPos;
		thrts.Vector3D GatherFirstPos;
		thrts.Vector3D GatherPos;
		thrts.Vector3D GatherRunPos;
		thrts.Vector3D EnPos;
		
		thrts.Vector2D AttackPos = new thrts.Vector2D();
		int around = 10;
		int aroundplus = 11;
		int aroundmin = 4;

		public override void OnInitialize(thrts.ICOMController com)
		{
			var homebases = com.GetMyBuildings(_ => _.Parameter.GetType() == typeof(HomeBase));

			foreach (var home in homebases)
			{
				FirstHome = home;
				InitPos = home.Pos;
				GatherPos = InitPos;
				GatherRunPos = InitPos;
				GatherFirstPos = InitPos;
				if (InitPos.X < com.Faction.World.Map.Count * thrts.Def.MapTipLengthOnField / 2) { GatherPos.X += 2 * 32; GatherRunPos.X += 3 * 32; GatherFirstPos.X -= 2 * 32; }
				else { GatherPos.X -= 2 * 32; GatherRunPos.X -= 3 * 32; GatherFirstPos.X += 2 * 32; }
				if (InitPos.Y < com.Faction.World.Map.Count * thrts.Def.MapTipLengthOnField / 2) { GatherPos.Y += 2 * 32; GatherRunPos.Y += 3 * 32; GatherFirstPos.Y -= 2 * 32; }
				else { GatherPos.Y -= 2 * 32; GatherRunPos.Y -= 3 * 32; GatherFirstPos.Y += 2 * 32; }
			}

			int r = 100000;
			homebases = com.GetEnemyBuildings(_ => Common.IsHome(_.Parameter));
			foreach (var home in homebases)
			{
				int temp = Common.GetR(InitPos, EnPos);
				if (r == 100000 || temp < r)
				{
					EnPos = home.Pos;
					r = temp;
					if (home.Parameter.GetType() == typeof(Building.Green.HomeBase)) toGreen = true;
					else toGreen = false;
				}
			}

			uniques = com.GetMyUnits(_ => _.Parameter.IsUnique);

			if (instant) uniquestart = 0;

			//com.Faction.SetResource(0, 10000); com.Faction.SetResource(1, 10000);
		}

		public override void OnUpdate(thrts.ICOMController com)
		{
			if (com.Difficulty == thrts.COMDifficulty.Practice) return;

			time++;

			// 資源収集(Normal以外のCOMはチート)
			Common.Cheat(com, time, ref instant, ref uniquestart);

			Common.Debug(com);
			//com.Faction.SetResource(0, 1000);
			//com.Faction.SetResource(1, 1000);

			if (time == 0)
			{
				var homebases = com.GetMyBuildings(_ => _.Parameter.GetType() == typeof(HomeBase));

				foreach (var home in homebases)
				{
					InitPos = home.Pos;
				}

				if (com.Faction.World.UnitManager.GetUnits(_ => _.Faction.IsNeutral && _.HP <= 200).Count() <= 8)
				{
					instant = false;
					uniquestart = 60;
				}
			}

			//ラリー設定
			if (time % (30 * 13) == 6)
			{
				/*var homebases = com.GetMyBuildings(_ => _.Parameter.GetType() == typeof(HomeBase));

				foreach (var home in homebases)
				{
					var res = com.GetMyBuildings(_ => _.Parameter.Name == "酒回収施設" && _.IsComplete && _.WorkerCount < 6);
					if (res.Count() == 0) res = com.GetMyBuildings(_ => _.Parameter.Name == "霊力回収施設" && _.IsComplete && _.WorkerCount < 6);
					if (res.Count() != 0) com.World.BuildingManager.SelectTarget(new[] { home }, res.First(), false);
				}*/
			}
			if (time % (30 * 20) == 4)
			{
				var builds = com.GetMyBuildings(_ => _.Parameter.GetType() != typeof(HomeBase));

				foreach (var bs in builds)
				{
					if (time < 30 * 150)
					{
						com.World.BuildingManager.SelectTarget(new[] { bs }, new thrts.Vector2D(GatherFirstPos.X, GatherFirstPos.Y), false);
					}
					else
					{
						var bsPos = bs.Pos;
						var bsgPos = bsPos;
						if (bsPos.X < com.Faction.World.Map.Count * thrts.Def.MapTipLengthOnField / 2) bsgPos.X += 2 * 32;
						else bsgPos.X -= 2 * 32;
						if (bsPos.Y < com.Faction.World.Map.Count * thrts.Def.MapTipLengthOnField / 2) bsgPos.Y += 2 * 32;
						else bsgPos.Y -= 2 * 32;
						com.World.BuildingManager.SelectTarget(new[] { bs }, new thrts.Vector2D(bsgPos.X, bsgPos.Y), false);
					}
				}
			}

			//資源駐留
			if (time % (30 * 2) == 5)
			{
				var neets = com.GetMyUnits(_ => _.Parameter.GetType() == typeof(Farmer) && _.ActualAction == thrts.UnitAction.Free && !_.IsEscaping);
				if (neets.Count() >= 2)
				{
					if (com.Difficulty != thrts.COMDifficulty.Lunatic)
						Common.CollectResource(com, 5);
					else
						Common.CollectResource(com);
				}
			}

			//ヒロイン生産
			if (time % (30 * 1) == 1 && (time > (30 * uniquestart) || com.Faction.GetResource(0) > 500))
			{
				StopForUnique = false;
				if (!flag.ContainsKey("1st生産") && com.Faction.GetResource(0) >= 150 && (FirstHome == null || !FirstHome.HasProductionQueue())) Common.SetFlag(flag, "1st生産");
				Common.CreateUnit(com, typeof(HomeBase), typeof(Yuyuko), "Black");

				//ヒロイン再生産優先
				if (time > (30 * 100) && com.GetMyUnits(_ => _.Parameter.IsUnique).Count() == 0)
				{
					var b = com.GetMyBuildings(_ => _.Parameter.GetType() == typeof(HomeBase)).FirstOrDefault();
					if (b != null && !b.HasProductionQueue())
					{
						StopForUnique = true;
						return;
					}
				}
			}

			//ユニーク最優先時除外
			if (!StopForUnique)
			{
				// 資源地作成
				if (time % (30 * 2) == 0)
				{
					var pro0 = com.GetMyBuildings(_ => _.Parameter.GetType() == typeof(ProduceResType0));
					produce0count = pro0.Count();
					if (produce0count < 3) NeedResource = Common.CreateResource(com, typeof(ProduceResType0), InitPos, 9, 2);

					var pro1 = com.GetMyBuildings(_ => _.Parameter.GetType() == typeof(ProduceResType1));
					produce1count = pro1.Count();
					if (produce1count >= 2) Common.SetFlag(flag, "全資源設置");
					if (instant)
					{
						if (produce1count < 1) NeedResource = Common.CreateResource(com, typeof(ProduceResType1), InitPos, 9);
						if (produce1count < 2) NeedResource = Common.CreateResource(com, typeof(ProduceResType1), InitPos, 9);
					}
					else
					{
						if (time > 30 * 100 && produce1count < 1) NeedResource = Common.CreateResource(com, typeof(ProduceResType1), InitPos, 9);
						if (low02count > 1 && produce1count < 2 && (com.Faction.GetResource(0) >= 200 || com.Faction.GetResource(0) < 140)) NeedResource = Common.CreateResource(com, typeof(ProduceResType1), InitPos, 9);
					}
				}

				// 魔法陣生成
				/*if (time % (30 * 2) == 1)
				{
					var barraks = com.GetMyBuildings(_ => _.Parameter.GetType() == typeof(Barrack));
					barrakscount = barraks.Count();
					if (barrakscount < 1) NeedResource = Common.CreateBuilding(com, typeof(Barrack), InitPos, aroundmin, around - 4, time);
					if (barrakscount < 2 && flag.ContainsKey("1st生産") && (super1count > 0 || factoryscount > 0) && low03count > 1 && Common.HasQue(com, FirstHome)) NeedResource = Common.CreateBuilding(com, typeof(Barrack), InitPos, aroundmin, around, time);
				}*/

				// 農民生成
				if (time % (30 * 1) == 1)
				{
					var farmers = com.GetMyUnits(_ => _.Parameter.GetType() == typeof(Farmer)).Where(__ => true/*!__.IsEscaping*/);
					farmercount = farmers.Count();
					if (farmercount <= 31 && farmercount < (5 + time / (30 * 15))) Common.CreateFarmer(com);
					//if (farmercount < 8 && barrakscount >= 2) Common.CreateFarmer(com);
				}

				// 研究所生成 & 研究
				if (time % (30 * 2) == 45)
				{
					var blacksmiths = com.GetMyBuildings(_ => _.Parameter.GetType() == typeof(BlackSmith));
					blacksmithcount = blacksmiths.Count();
					if (blacksmithcount < 1 && flag.ContainsKey("1st生産") && (factoryscount > 0 && airportcount > 0) && (Common.HasQue(com, FirstHome) || com.Faction.GetResource(0) >= 500)) NeedResource = Common.CreateBuilding(com, typeof(BlackSmith), InitPos, aroundmin, aroundplus, time);

					Common.PushTech(com, typeof(BlackSmith), "鍛冶");
				}

				// 上級魔法陣生成
				if (time % (30 * 2) == 45)
				{
					var factorys1 = com.GetMyBuildings(_ => _.Parameter.GetType() == typeof(Chireiden));
					super1count = factorys1.Count();
					if (super1count < 1 && com.Faction.GetResource(1) >= 100) NeedResource = Common.CreateBuilding(com, typeof(Chireiden), InitPos, aroundmin, around, time);
					if (super1count < 6 && factoryscount > 0 && airportcount > 0 && (Common.HasQue(com, FirstHome) || com.Faction.GetResource(0) >= 350 + super1count * 100)) NeedResource = Common.CreateBuilding(com, typeof(Chireiden), InitPos, aroundmin, around + 2, time);
				}
				if (time % (30 * 2) == 46)
				{
					var factorys = com.GetMyBuildings(_ => _.Parameter.GetType() == typeof(Factory));
					factoryscount = factorys.Count();
					if (factoryscount < 1 && com.Faction.GetResource(1) >= 100 && (Common.HasQue(com, FirstHome) || com.Faction.GetResource(1) >= 600)) NeedResource = Common.CreateBuilding(com, typeof(Factory), InitPos, aroundmin, aroundplus, time);

				}
				if (time % (30 * 2) == 49)
				{
					if (super1count > 0 && factoryscount > 0)
					{
						var airs = com.GetMyBuildings(_ => _.Parameter.GetType() == typeof(Airport));
						airportcount = airs.Count();
						if (com.Faction.GetResource(0) >= (airportcount + 1) * 350 && com.Faction.GetResource(1) >= (airportcount + 1) * 350) NeedResource = Common.CreateBuilding(com, typeof(Airport), InitPos, aroundmin, aroundplus, time);
					}
				}

				//スキル使用
				if (time % 5 == 0)
				{
					foreach (var uni in uniques)
					{
						if (uni.Parameter.GetType() == typeof(Yuyuko))
						{
							Common.UseSpell(uni, uni.Parameter.SpellParams[2], (int)Common.GetNowSpell(uni, 2).MaxRange, true, 0, true);
							Common.UseSpell(uni, uni.Parameter.SpellParams[1]);
						}

						//スキル使用後AttackMoveを再設定
						if (time % 30 == 0 && uni.UserValues.ContainsKey("com攻撃") && uni.ActualAction == thrts.UnitAction.Free)
						{
							com.World.UnitManager.AttackMove(new[] { uni.UniqueID }, AttackPos, false);
						}
					}
				}

				//レベルアップ
				if (time % (30 * 1) == 10)
				{
					uniques = com.GetMyUnits(_ => _.Parameter.IsUnique);
					foreach (var uni in uniques)
					{
						if (!uni.Faction.World.IsInPreparatoryPeriod())
						{
							if (uni.Parameter.GetType() == typeof(Yuyuko))
							{
								//Common.LVUP(uni, uni.Parameter.SpellParams[2].Name);
								//Common.LVUP(uni, uni.Parameter.SpellParams[3].Name);
								Common.LVUP(uni, uni.Parameter.SpellParams[2].Name);
								Common.LVUP(uni, uni.Parameter.SpellParams[0].Name);
								Common.LVUP(uni, uni.Parameter.SpellParams[1].Name);
							}
						}

						//クリーピング
						Common.Creeping(com, uni, instant, flag, InitPos, EnPos, GatherFirstPos, ref GatherPos, time, ref stoptime);
					}
				}

				//2nd
				if (time % (30 * 4) == 0)
				{
					var homebases = com.GetMyBuildings(_ => _.Parameter.GetType() == typeof(HomeBase));
					homecount = homebases.Count();
					/*if (homecount < 2
						&& com.Faction.GetBuildingParameter(typeof(HomeBase).FullName).Costs[0] <= com.Faction.GetResource(0))
					{
						foreach (var area in com.World.AllPurposeArea)
						{
							if (area.Name.StartsWith("HomeBase_Sub"))
							{
								var a = area as thrts.AreaRectangle;
								thrts.Vector3D Pos = new thrts.Vector3D(new thrts.Vector2D((a.Start.X + a.End.X) / 2, (a.Start.Y + a.End.Y) / 2), 0);
								NeedResource = Common.CreateBuilding(com, typeof(HomeBase), Pos, 0, 1, time);
							}
						}
					}*/
				}

				//兵士生産
				if (time % (30 * 2) == 15)
				{
					orincount = com.GetMyUnits(_ => _.Parameter.GetType() == typeof(Orin)).Count();
					satoricount = com.GetMyUnits(_ => _.Parameter.GetType() == typeof(Satori)).Count();

					Common.CreateUnit(com, typeof(Factory), typeof(Youmu), "Black", 100);
					if (orincount <= satoricount * 2)
						Common.CreateUnit(com, typeof(Chireiden), typeof(Orin), "Black", 100);
					if (orincount != 0)
						Common.CreateUnit(com, typeof(Chireiden), typeof(Satori), "Black", 100);
					Common.CreateUnit(com, typeof(Chireiden), typeof(Orin), "Black", 100);

					if (com.Difficulty == thrts.COMDifficulty.Hard || com.Difficulty == thrts.COMDifficulty.Lunatic)
					{
						Common.CreateUnit(com, typeof(Airport), typeof(FlyBomber), "Black", 100);
					}
				}

				if (time % (30 * 2) == 59 && time > (30 * 52))
				{
					low03count = com.GetMyUnits(_ => _.Parameter.GetType() == typeof(Low03)).Count();
					low02count = com.GetMyUnits(_ => _.Parameter.GetType() == typeof(Low02)).Count();
					// 兵士生産
					if (flag.ContainsKey("1st生産") && produce1count  >= 2 && (super1count > 0 || low02count == 0))
					{
						var p0s = com.GetMyBuildings(_ => _.Parameter.GetType() == typeof(ProduceResType0) && _.HasProductionQueue());
						var p1s = com.GetMyBuildings(_ => _.Parameter.GetType() == typeof(ProduceResType1) && _.HasProductionQueue());
						if ((super1count == 0 && factoryscount == 0 && super2count == 0) || com.Faction.GetResource(1) < 25)
						{
							if (p0s.Count() == 0 && (com.Faction.GetResource(0) >= 170 || Common.HasQue(com, FirstHome)))
								Common.CreateUnit(com, typeof(ProduceResType0), typeof(Low02), "Black", 1);
						}
						if (super1count != 0)
							if ((p1s.Count() == 0 || com.Faction.GetResource(0) >= 170) && Common.HasQue(com, FirstHome))
								Common.CreateUnit(com, typeof(ProduceResType1), typeof(Low03), "Black", 1);
					}
				}
			}
			//ユニーク最優先時除外 ここまで

			//失敗した建物再建築
			if (time % (30 * 8) == 7)
			{
				Common.ReBuild(com, ref LastProgress, ref LastBuilding);
			}

			//1箇所に集合
			if (time % (30 * 2) == 0 && time > 30 * 150)
			{
				Common.Gathering(com, GatherPos);
			}

			// 定期的に突撃する
			if (time % (30 * 10) == 0)
			{
				Common.Attack(com, ref threshold, ref AttackPos, GatherPos, EnPos, GatherFirstPos);
			}
			// 攻撃追加、逃走
			if (time % (30 * 1) == 0)
			{
				Common.ReinforceAndRun(com, threshold, ref AttackPos, GatherPos, time);
			}
			//農民反撃
			if (time % (30 * 1) == 0)
			{
				Common.Counter(com, InitPos, FirstHome);
			}

			if (time % (3) == 0)
			{
				Common.StopNeutralAttack(com, flag, GatherFirstPos, AttackPos);
			}
			
			/*if (time % 30 == 1 && time < 30 * 110)
			{
				var en = com.GetEnemyUnits(_ => _.Parameter.IsUnique).FirstOrDefault();
				if (en != null)
				{
					if (Common.GetR(en.Pos, InitPos) < 50 * 32)
					{
						var lows = com.GetMyUnits(_ => _.Parameter.GetType() != typeof(Farmer) && !_.Parameter.IsUnique).ToArray();
						foreach(var low in lows)
						{
							com.World.UnitManager.AttackMove(new[] { low.UniqueID }, new thrts.Vector2D(en.Pos.X, en.Pos.Y), false);
						}
					}
				}
			}*/

		}
	}
}
#endif