﻿
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LotusCraft.Effect.Blue
{
	public class YukifuEffect : thrts.EffectParameter
	{
		public YukifuEffect() 
		{
			EffectPath = "LotusCraft/3D/Effect/cirno_blizzard_area.efk";
			LightEffectPath = "LotusCraft/3D/Effect/cirno_blizzard_area_light.efk";
		}
	}

	public class ShimofuEffect : thrts.EffectParameter
	{
		public ShimofuEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/cirno_frost_area.efk";
			LightEffectPath = "LotusCraft/3D/Effect/cirno_frost_area_light.efk";
		}
	}

	public class IcicleEffect : thrts.EffectParameter
	{
		public IcicleEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/cirno_icicle_area.efk";
		}
	}

	public class PerfectEffect : thrts.EffectParameter
	{
		public PerfectEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/cirno_perfect_area.efk";
			LightEffectPath = "LotusCraft/3D/Effect/cirno_perfect_area_light.efk";
		}
	}

	public class FreezingEffect : thrts.EffectParameter
	{
		public FreezingEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/cirno_freezing.efk";
		}
	}

	public class ChilnohitEffect : thrts.EffectParameter
	{
		public ChilnohitEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/cirno_hit.efk";
		}
	}

	public class ChirnoFreezingTextureEffect : thrts.TextureEffectParameter
	{
		public ChirnoFreezingTextureEffect()
		{
			Animation = new thrts.TextureAnimation();
			Animation.Width = 64;
			Animation.Height = 64;
			Animation.CenterPosition = thrts.CenterPosition.MiddleMiddle;
			Animation.FrameCount = 1;
			Animation.FrameTime = 1;
			Animation.Count.X = 1;
			Animation.Count.Y = 1;
			Animation.AlphaBlend = thrts.AlphaBlend.Blend;
			Animation.LoopType = thrts.TextureAnimation.AnimetionLoopType.Loop;
			Animation.Path = "LotusCraft/Image/TextureEffect/snow01";

			Time = int.MaxValue;
			IsHorizontal = true;
			Is3DMode = true;
		}
	}
}

