﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LotusCraft.Effect.Green
{
	public class AliceLvUpEffect : thrts.EffectParameter
	{
		public AliceLvUpEffect ()
		{
			EffectPath = "LotusCraft/3D/Effect/common_levelup.efk";
		}
	}
	public class SemiAutoEffect : thrts.EffectParameter
	{
		public SemiAutoEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/alice_semi.efk";
		}
	}
	public class ParadeSelfEffect : thrts.EffectParameter
	{
		public ParadeSelfEffect ()
		{
			EffectPath = "LotusCraft/3D/Effect/alice_lemming_self.efk";
		}
	}
	public class ParadeDollEffect : thrts.EffectParameter
	{
		public ParadeDollEffect ()
		{
			EffectPath = "LotusCraft/3D/Effect/alice_lemming_effect.efk";
		}
	}
	public class ParadeDollTextureEffect : thrts.TextureEffectParameter
	{
		public ParadeDollTextureEffect()
		{
			Animation = new thrts.TextureAnimation();
			Animation.Width = 64;
			Animation.Height = 64;
			Animation.CenterPosition = thrts.CenterPosition.MiddleMiddle;
			Animation.FrameCount = 9;
			Animation.FrameTime = 3;
			Animation.Count.X = 9;
			Animation.Count.Y = 1;
			Animation.AlphaBlend = thrts.AlphaBlend.Add;
			Animation.LoopType = thrts.TextureAnimation.AnimetionLoopType.Loop;
			Animation.Path = "LotusCraft/Image/TextureEffect/alice_lemming_effect";

			Time = int.MaxValue;
			IsHorizontal = true;
			Is3DMode = true;
		}
	}
	public class ParadeHitEffect : thrts.EffectParameter
	{
		public ParadeHitEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/alice_lemming_hit.efk";
		}
	}
	public class WarEffect : thrts.EffectParameter
	{
		public WarEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/alice_war_effect.efk";
		}
	}

	public class WarTextureEffect : thrts.TextureEffectParameter
	{
		public WarTextureEffect()
		{
			Animation = new thrts.TextureAnimation();
			Animation.Width = 32;
			Animation.Height = 32;
			Animation.CenterPosition = thrts.CenterPosition.MiddleMiddle;
			Animation.FrameCount = 1;
			Animation.FrameTime = 4;
			Animation.Count.X = 1;
			Animation.Count.Y = 1;
			Animation.AlphaBlend = thrts.AlphaBlend.Add;
			Animation.LoopType = thrts.TextureAnimation.AnimetionLoopType.Loop;
			Animation.Path = "LotusCraft/Image/TextureEffect/alice_war_effect";

			Time = int.MaxValue;
			IsHorizontal = true;
			Is3DMode = true;
			RotationVelocity = 20;
			Scale = 1.3f;
		}
	}

	public class WireEffect : thrts.EffectParameter
	{
		public WireEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/alice_wire_effect.efk";
		}
	}
}
