﻿#if !_TRIAL
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LotusCraft.Effect.Green
{
	
	public class MigiteEffect : thrts.EffectParameter
	{
		public MigiteEffect ()
		{
			EffectPath = "LotusCraft/3D/Effect/kasen_migite_effect.efk";
		}
	}

	public class MichibikuAreaEffect : thrts.EffectParameter
	{
		public MichibikuAreaEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/kasen_michibiku_area.efk";
		}
	}

	public class MichibikuEffect : thrts.EffectParameter
	{
		public MichibikuEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/kasen_michibiku_effect.efk";
		}
	}

	public class ShugyouEffect : thrts.EffectParameter
	{
		public ShugyouEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/kasen_shugyou_effect.efk";
		}
	}

	public class YukakuEffect : thrts.EffectParameter
	{
		public YukakuEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/kasen_yukaku_area.efk";
		}
	}

	public class YukakuTextureEffect : thrts.TextureEffectParameter
	{
		public YukakuTextureEffect()
		{
			Animation = new thrts.TextureAnimation();
			Animation.Width = 32;
			Animation.Height = 32;
			Animation.CenterPosition = thrts.CenterPosition.MiddleMiddle;
			Animation.FrameCount = 4;
			Animation.FrameTime = 4;
			Animation.Count.X = 4;
			Animation.Count.Y = 1;
			Animation.AlphaBlend = thrts.AlphaBlend.Add;
			Animation.LoopType = thrts.TextureAnimation.AnimetionLoopType.Loop;
			Animation.Path = "LotusCraft/Image/TextureEffect/kasen_yukaku_effect";

			Time = int.MaxValue;
			IsHorizontal = true;
			Is3DMode = true;

		}
	}
}
#endif
