﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LotusCraft.Effect.Red
{
	public class HakuchuShotEffect : thrts.EffectParameter
	{
		public HakuchuShotEffect ()
		{
			EffectPath = "LotusCraft/3D/Effect/sanae_hakuchu_area.efk";
		}
	}
	public class HakuchuSelfEffect : thrts.EffectParameter
	{
		public HakuchuSelfEffect ()
		{
			EffectPath = "LotusCraft/3D/Effect/sanae_hakuchu_self.efk";
		}
	}

	public class HanjoThrowEffect : thrts.EffectParameter
	{
		public HanjoThrowEffect ()
		{
			EffectPath = "LotusCraft/3D/Effect/sanae_fire.efk";
		}
	}
	public class HanjoHitEffect : thrts.EffectParameter
	{
		public HanjoHitEffect ()
		{
			EffectPath = "LotusCraft/3D/Effect/sanae_hanjou_hit.efk";
		}
	}

	public class KaminokazeTextureEffect : thrts.TextureEffectParameter
	{
		public KaminokazeTextureEffect()
		{
			Animation = new thrts.TextureAnimation();
			Animation.Width = 64;
			Animation.Height = 64;
			Animation.CenterPosition = thrts.CenterPosition.MiddleMiddle;
			Animation.FrameCount = 32;
			Animation.FrameTime = 2;
			Animation.Count.X = 8;
			Animation.Count.Y = 4;
			Animation.AlphaBlend = thrts.AlphaBlend.Add;
			Animation.LoopType = thrts.TextureAnimation.AnimetionLoopType.Loop;
			Animation.Path = "LotusCraft/Image/TextureEffect/sanae_kaminokaze_effect";

			Time = int.MaxValue;
			IsHorizontal = true;
			Is3DMode = true;
		}
	}

	public class KamiNoKazeEffect : thrts.EffectParameter
	{
		public KamiNoKazeEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/sanae_kaminokaze_effect.efk";
		}
	}
	public class KamiNoKazeAreaEffect : thrts.EffectParameter
	{
		public KamiNoKazeAreaEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/sanae_kaminokaze_area.efk";
		}
	}
	public class KamiNoKazeSelfEffect : thrts.EffectParameter
	{
		public KamiNoKazeSelfEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/sanae_kaminokaze_self.efk";
		}
	}

	public class KouanAreaEffect : thrts.EffectParameter
	{
		public KouanAreaEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/sanae_kouan_area.efk";
		}
	}
	public class KouanChargeEffect : thrts.EffectParameter
	{
		public KouanChargeEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/sanae_kouan_charge.efk";
		}
	}
	public class KouanHitEffect : thrts.EffectParameter
	{
		public KouanHitEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/sanae_kouan_hit.efk";
		}
	}
	public class KouanSelfEffect : thrts.EffectParameter
	{
		public KouanSelfEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/sanae_kouan_self.efk";
		}
	}
}
