﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LotusCraft.Obstacle
{
	public class HakureiShrine : thrts.UnselectableObstacleParameter
	{
		public HakureiShrine()
		{
			Name = "博麗神社";
			Size = 6;
			ObjectPath = "LotusCraft/3D/Obstacle/HakureiShrine.mdl";
		}
	}

	public class Torii : thrts.UnselectableObstacleParameter
	{
		public Torii()
		{
			Name = "鳥居";
			Size = 4;
			ObjectPath = "LotusCraft/3D/Obstacle/Torii.mdl";
		}
	}

	public class Tourou : thrts.UnselectableObstacleParameter
	{
		public Tourou()
		{
			Name = "灯籠";
			Size = 1;
			ObjectPath = "LotusCraft/3D/Obstacle/Tourou.mdl";
		}
	}

	public class Tree01 : thrts.UnselectableObstacleParameter
	{
		public Tree01()
		{
			Name = "木1";
			Size = 2;
			ObjectPath = "LotusCraft/3D/Obstacle/Tree01.mdl";
		}
	}

	public class SunFlower : thrts.UnselectableObstacleParameter
	{
		public SunFlower()
		{
			Name = "向日葵";
			Size = 1;
			ObjectPath = "LotusCraft/3D/Obstacle/SunFlower.mdl";
		}
	}

	public class Mushroom01 : thrts.UnselectableObstacleParameter
	{
		public Mushroom01()
		{
			Name = "きのこ1";
			Size = 1;
			ObjectPath = "LotusCraft/3D/Obstacle/Mushroom01.mdl";
		}
	}

	public class Bamboo01 : thrts.UnselectableObstacleParameter
	{
		public Bamboo01()
		{
			Name = "竹1";
			Size = 1;
			ObjectPath = "LotusCraft/3D/Obstacle/Bamboo01.mdl";
		}
	}

	public class Stone01 : thrts.UnselectableObstacleParameter
	{
		public Stone01()
		{
			Name = "石1";
			Size = 1;
			ObjectPath = "LotusCraft/3D/Obstacle/Stone01.mdl";
		}
	}

	public class KyuutoNagayaSingle : thrts.UnselectableObstacleParameter
	{
		public KyuutoNagayaSingle()
		{
			Name = "長屋・単体(旧都)";
			Size = 4;
			ObjectPath = "LotusCraft/3D/Obstacle/KyuutoNagaya_Single.mdl";
		}
	}

	public class KyuutoNagayaLeft : thrts.UnselectableObstacleParameter
	{
		public KyuutoNagayaLeft()
		{
			Name = "長屋・左(旧都)";
			Size = 4;
			ObjectPath = "LotusCraft/3D/Obstacle/KyuutoNagaya_Left.mdl";
		}
	}

	public class KyuutoNagayaRight : thrts.UnselectableObstacleParameter
	{
		public KyuutoNagayaRight()
		{
			Name = "長屋・右(旧都)";
			Size = 4;
			ObjectPath = "LotusCraft/3D/Obstacle/KyuutoNagaya_Right.mdl";
		}
	}

	public class KyuutoNagayaMiddle : thrts.UnselectableObstacleParameter
	{
		public KyuutoNagayaMiddle()
		{
			Name = "長屋・中間(旧都)";
			Size = 4;
			ObjectPath = "LotusCraft/3D/Obstacle/KyuutoNagaya_Middle.mdl";
		}
	}

	public class HitozatoMinka1 : thrts.UnselectableObstacleParameter
	{
		public HitozatoMinka1()
		{
			Name = "人里・民家1";
			Size = 4;
			ObjectPath = "LotusCraft/3D/Obstacle/HitozatoMinka1.mdl";
		}
	}

	public class HitozatoNagaya1 : thrts.UnselectableObstacleParameter
	{
		public HitozatoNagaya1()
		{
			Name = "人里・長屋1";
			Size = 4;
			ObjectPath = "LotusCraft/3D/Obstacle/HitozatoNagaya1.mdl";
		}
	}

	public class HitozatoNagaya2 : thrts.UnselectableObstacleParameter
	{
		public HitozatoNagaya2()
		{
			Name = "人里・長屋2";
			Size = 4;
			ObjectPath = "LotusCraft/3D/Obstacle/HitozatoNagaya2.mdl";
		}
	}

	public class Kakine1 : thrts.UnselectableObstacleParameter
	{
		public Kakine1()
		{
			Name = "垣根1";
			Size = 2;
			ObjectPath = "LotusCraft/3D/Obstacle/Kakine1.mdl";
		}
	}
}
