﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LotusCraft.Spell.Black
{
	class Blank:thrts.SpellParameter<thrts.IUnit>
	{
		public Blank()
		{
			DefaultLevel = 0;
			MaxLevel = 3;
			Name = "未設定";
			string basePath = "Black/Spell/Blank/";
			/// レベル別の能力説明
			EffectDescriptions = new string[]
			{
				"Lv1効果",
				"Lv2効果",
				"Lv3効果",
			};

			/// ボタンの位置
			ButtonPosX = thrts.ButtonPosition._3;
			ButtonPosY = thrts.ButtonPosition._2;
			LvUpButtonPosX = ButtonPosX;
			LvUpButtonPosY = thrts.ButtonPosition._1;

			/// オートキャストの生成
			SpellAutoCasts = null;
			/// スペルのボタンを生成
			SpellButtons = new thrts.ButtonParameter<thrts.IUnit>[]
			{
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "0",0),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "0",1),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "0",2),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "0",3),
			};
			LevelUpSpellButton = new LotusCraft.Button.LevelUpSpellButton(this, basePath + "LvUp");
		}
	}
}
