﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;

namespace LotusCraft.Building
{
	class BuildingUtls
	{
		static public void ShowComplete(thrts.IBuilding building)
		{
			if (building.Faction.World.CurrentTime > 10)
			{
				building.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.CreatedBuilding).FullName, building.Pos);

				var offset = new Vector3D(0, 0, 1);
				IEffect ceffect = building.Faction.World.EffectManager.CreateEffect(typeof(Effect.Common.CompleteBuildingEffect).FullName, building.Pos + offset);
				var scale = 3.0f * building.Parameter.Size;
				ceffect.SetScale(new Vector3D(scale, scale, scale));
			}
		}
	}
}
