﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;

namespace LotusCraft.Button
{
	public class AutoButton<ButtonHolder> : thrts.ButtonParameter<ButtonHolder>
	{
		public AutoButton(string text, ButtonPosition x, ButtonPosition y,
			string buttonPath)
		{
			Position = Tuple.Create(x, y);
			ButtonImagePath = "LotusCraft/Image/Button/" + buttonPath;
			MouseOverTextFunc = _ =>
			(
				new[]
				{
					new ColorTextLine
						(
							new ColorText(text)
						)
				}
			);
			Kind = ButtonKind.Dummy;
		}
	}
}
