﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LotusCraft.Effect.Black
{
#if !_TRIAL
	#region ヤマメエフェクト
	public class YamameCaptureArea : thrts.EffectParameter
	{
		public YamameCaptureArea()
		{
			EffectPath = "System/Effect/yamame_capture_area.efk";
		}
	}

	public class YamameCaptureCharge : thrts.EffectParameter
	{
		public YamameCaptureCharge()
		{
			EffectPath = "System/Effect/yamame_capture_charge.efk";
		}
	}

	public class YamameCaptureEffect : thrts.EffectParameter
	{
		public YamameCaptureEffect()
		{
			EffectPath = "System/Effect/yamame_capture_effect.efk";
		}
	}

	public class YamameFilledArea : thrts.EffectParameter
	{
		public YamameFilledArea()
		{
			EffectPath = "System/Effect/yamame_filled_area.efk";
		}
	}

	public class YamameNetubyouArea : thrts.EffectParameter
	{
		public YamameNetubyouArea()
		{
			EffectPath = "LotusCraft/3D/Effect/yamame_netubyou_area.efk";
		}
	}

	public class YamameRopeArea : thrts.EffectParameter
	{
		public YamameRopeArea()
		{
			EffectPath = "System/Effect/yamame_rope_area.efk";
		}
	}

	#endregion
#endif
	public class Arrow : thrts.EffectParameter
	{
		public Arrow()
		{
			EffectPath = "System/Effect/ClickPoint.efk";
		}
	}

	public class CreateBuilding : thrts.EffectParameter
	{
		public CreateBuilding()
		{
			EffectPath = "LotusCraft/3D/Effect/CreateBuilding.efk";
		}
	}
	public class BreakBuilding : thrts.EffectParameter
	{
		public BreakBuilding()
		{
			EffectPath = "LotusCraft/3D/Effect/BreakBuilding.efk";
		}
	}

	public class Stronghold : thrts.EffectParameter
	{
		public Stronghold()
		{
			EffectPath = "LotusCraft/3D/Effect/Stronghold_Black.efk";
		}
	}

	public class Barracks : thrts.EffectParameter
	{
		public Barracks()
		{
			EffectPath = "LotusCraft/3D/Effect/common_barracks.efk";
		}
	}

	public class Factories : thrts.EffectParameter
	{
		public Factories()
		{
			EffectPath = "LotusCraft/3D/Effect/Factory.efk";
		}
	}

	public class FactoriesReactor : thrts.EffectParameter
	{
		public FactoriesReactor()
		{
			EffectPath = "LotusCraft/3D/Effect/common_factories_reactor.efk";
		}
	}

	public class Airports : thrts.EffectParameter
	{
		public Airports()
		{
			EffectPath = "LotusCraft/3D/Effect/Airport.efk";
		}
	}

	public class CollectAlcohol : thrts.EffectParameter
	{
		public CollectAlcohol()
		{
			EffectPath = "LotusCraft/3D/Effect/CollectAlcohol.efk";
		}
	}

	public class CollectPowerStone : thrts.EffectParameter
	{
		public CollectPowerStone()
		{
			EffectPath = "LotusCraft/3D/Effect/CollectPowerStone.efk";
		}
	}

	public class DeadUnitEffect : thrts.EffectParameter
	{
		public DeadUnitEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/common_unit_dead.efk";
		}
	}

	public class DeadUniqueEffect : thrts.EffectParameter
	{
		public DeadUniqueEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/common_unique_dead.efk";
		}
	}

	public class SatoriTargetTextureEffect : thrts.TextureEffectParameter
	{
		public SatoriTargetTextureEffect()
		{
			Animation = new thrts.TextureAnimation();
			Animation.Width = 64;
			Animation.Height = 64;
			Animation.CenterPosition = thrts.CenterPosition.MiddleMiddle;
			Animation.FrameCount = 1;
			Animation.FrameTime = 1;
			Animation.Count.X = 1;
			Animation.Count.Y = 1;
			Animation.AlphaBlend = thrts.AlphaBlend.Blend;
			Animation.LoopType = thrts.TextureAnimation.AnimetionLoopType.Loop;
			Animation.Path = "LotusCraft/Image/TextureEffect/satori_skill";

			Time = int.MaxValue;
			IsHorizontal = true;
			Is3DMode = true;
		}
	}

	public class Rin_Shikigami_HitRedTextureEffect : thrts.TextureEffectParameter
	{
		public Rin_Shikigami_HitRedTextureEffect()
		{
			Animation = new thrts.TextureAnimation();
			Animation.Path = "LotusCraft/Image/TextureEffect/normalHitEffect";

			Animation.Offset.Y = 512 + 64;
			Animation.Width = 64;
			Animation.Height = 64;
			Animation.LoopType = thrts.TextureAnimation.AnimetionLoopType.Stop;
			Animation.FrameCount = 1024 / 64;
			Animation.FrameTime = 1;
			Animation.HasDirection = false;
			Animation.Count.X = 1024 / 64;
			Animation.Count.Y = 1;
			Animation.CenterPosition = thrts.CenterPosition.LowerMiddle;
			Animation.AlphaBlend = thrts.AlphaBlend.Add;
			Animation.Center.Y = -32;
			Animation.Scale.X = 1.4f * 3;
			Animation.Scale.Y = 1.4f * 3;

			Time = 1024 / 64;
		}
	}
}
