﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LotusCraft.Effect.Black
{
	public class CaptureAreaEffect : thrts.EffectParameter
	{
		public CaptureAreaEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/yamame_capture_area.efk";
		}
	}

	public class CaptureChargeEffect : thrts.EffectParameter
	{
		public CaptureChargeEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/yamame_capture_charge.efk";
		}
	}

	public class CaptureEffect : thrts.EffectParameter
	{
		public CaptureEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/yamame_capture_effect.efk";
		}
	}

	public class FilledEffect : thrts.EffectParameter
	{
		public FilledEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/yamame_filled_area.efk";
		}
	}

	public class NetubyouEffect : thrts.EffectParameter
	{
		public NetubyouEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/yamame_netubyou_area.efk";
		}
	}

	public class RopeEffect : thrts.EffectParameter
	{
		public RopeEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/yamame_rope_area.efk";
		}
	}

	public class YamameNetubyouTextureEffect : thrts.TextureEffectParameter
	{
		public YamameNetubyouTextureEffect()
		{
			Animation = new thrts.TextureAnimation();
			Animation.Path = "LotusCraft/Image/TextureEffect/acid";

			Animation.Width = 64;
			Animation.Height = 64;
			Animation.LoopType = thrts.TextureAnimation.AnimetionLoopType.Loop;
			Animation.FrameCount = 20;
			Animation.FrameTime = 1;
			Animation.HasDirection = false;
			Animation.Count.X = 10;
			Animation.Count.Y = 2;
			Animation.CenterPosition = thrts.CenterPosition.MiddleMiddle;
			Animation.AlphaBlend = thrts.AlphaBlend.Blend;

			Time = int.MaxValue;
			Animation.Scale = new thrts.Vector2D(2.0f, 2.0f);
		}
	}
}
