﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LotusCraft.Effect.Red
{
	public class CommonBolEffect : thrts.EffectParameter
	{
		public CommonBolEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/common_bol.efk";
		}
	}
	public class CommonBolAreaEffect : thrts.EffectParameter
	{
		public CommonBolAreaEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/common_bol_loop.efk";
		}
	}
	public class RangeCircleEffect : thrts.EffectParameter
	{
		public RangeCircleEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/RangeCircle.efk";
		}
	}

	
	public class HitSplashRedEffect : thrts.EffectParameter
	{
		public HitSplashRedEffect()
		{ 
			EffectPath = "LotusCraft/3D/Effect/HitSplash_red.efk";
		}
	}
	public class HitSplashBlueEffect : thrts.EffectParameter
	{
		public HitSplashBlueEffect()
		{ 
			EffectPath = "LotusCraft/3D/Effect/HitSplash_blue.efk";
		}
	}
	public class HitSplashGreenEffect : thrts.EffectParameter
	{
		public HitSplashGreenEffect()
		{ 
			EffectPath = "LotusCraft/3D/Effect/HitSplash_green.efk";
		}
	}

	public class HealEffect : thrts.EffectParameter
	{
		public HealEffect()
		{ 
			EffectPath = "LotusCraft/3D/Effect/HealUnit.efk";
		}
	}
	public class BackLightEffect : thrts.EffectParameter
	{
		public BackLightEffect()
		{ 
			EffectPath = "LotusCraft/3D/Effect/BackLight.efk";
		}
	}

	public class NamazuEarthquakeEffect : thrts.EffectParameter
	{
		public NamazuEarthquakeEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/namazu_earthquake.efk";
		}
	}
	public class FlandreDeadEffect : thrts.EffectParameter
	{
		public FlandreDeadEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/flandle_destroy.efk";
		}
	}

	public class StanEffect : thrts.EffectParameter
	{
		public StanEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/common_stun.efk";
		}
	}

	#region KaguyaMob
	
	public class MeirinMobAreaModelEffect : thrts.ModelEffectParameter
	{
		public MeirinMobAreaModelEffect()
		{
			ObjectPath = "LotusCraft/3D/Spell/danger_area01.mdl";
			Time = int.MaxValue / 4;
		}
	}
	

	public class KaguyaMobAreaEffect : thrts.EffectParameter
	{
		public KaguyaMobAreaEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/kaguya_m_area.efk";
		}
	}
	public class MeirinMobChangeEffect : thrts.EffectParameter
	{
		public MeirinMobChangeEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/meirin_m_effect.efk";
		}
	}
	
	public class KaguyaMobFlashEffect : thrts.EffectParameter
	{
		public KaguyaMobFlashEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/kaguya_m_flash.efk";
		}
	}
	
	public class KaguyaMobHitEffect : thrts.EffectParameter
	{
		public KaguyaMobHitEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/kaguya_m_hit.efk";
		}
	}
	
	public class MeirinMobHitBigEffect : thrts.EffectParameter
	{
		public MeirinMobHitBigEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/kaguya_m_hit_big.efk";
		}
	}
	#endregion

}
