﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LotusCraft.Effect.White
{
	public class NijuKekkaiTextureEffect : thrts.TextureEffectParameter
	{
		public NijuKekkaiTextureEffect()
		{
			Animation = new thrts.TextureAnimation();
			Animation.Width = 32;
			Animation.Height = 32;
			Animation.CenterPosition = thrts.CenterPosition.MiddleMiddle;
			Animation.FrameCount = 4;
			Animation.FrameTime = 4;
			Animation.Count.X = 4;
			Animation.Count.Y = 1;
			Animation.AlphaBlend = thrts.AlphaBlend.Add;
			Animation.LoopType = thrts.TextureAnimation.AnimetionLoopType.Loop;
			Animation.Path = "LotusCraft/Image/TextureEffect/reimu_nizyuu_effect";

			Time = int.MaxValue;
			IsHorizontal = true;
			Is3DMode = true;

		}
	}

	public class NijuKekkaiEffect : thrts.EffectParameter
	{
		public NijuKekkaiEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/reimu_nizyuu_effect.efk";
		}
	}

	public class NijuKekkaiAreaEffect : thrts.EffectParameter
	{
		public NijuKekkaiAreaEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/reimu_nizyuu_area.efk";
		}
	}

	public class KibakujinEffect : thrts.EffectParameter
	{
		public KibakujinEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/reimu_happou_effect.efk";
		}
	}
	public class KibakujinAreaEffect : thrts.EffectParameter
	{
		public KibakujinAreaEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/reimu_happou_area.efk";
		}
	}

	public class MusoHuinAreaEffect : thrts.EffectParameter
	{
		public MusoHuinAreaEffect ()
		{
			EffectPath = "LotusCraft/3D/Effect/reimu_huuin_area.efk";
		}
	}
	public class MusoHuinChargeEffect : thrts.EffectParameter
	{
		public MusoHuinChargeEffect ()
		{
			EffectPath = "LotusCraft/3D/Effect/reimu_huuin_charge.efk";
		}
	}
	public class MusoHuinRedBulletEffect : thrts.EffectParameter
	{
		public MusoHuinRedBulletEffect ()
		{
			EffectPath = "LotusCraft/3D/Effect/reimu_huuin_bullet_r_light.efk";
		}
	}
	public class MusoHuinBlueBulletEffect : thrts.EffectParameter
	{
		public MusoHuinBlueBulletEffect ()
		{
			EffectPath = "LotusCraft/3D/Effect/reimu_huuin_bullet_b_light.efk";
		}
	}
	public class MusoHuinGreenBulletEffect : thrts.EffectParameter
	{
		public MusoHuinGreenBulletEffect ()
		{
			EffectPath = "LotusCraft/3D/Effect/reimu_huuin_bullet_g_light.efk";
		}
	}

	public class MusoHuinRedHitEffect : thrts.EffectParameter
	{
		public MusoHuinRedHitEffect ()
		{
			EffectPath = "LotusCraft/3D/Effect/reimu_huuin_hit_r.efk";
		}
	}
	public class MusoHuinBlueHitEffect : thrts.EffectParameter
	{
		public MusoHuinBlueHitEffect ()
		{
			EffectPath = "LotusCraft/3D/Effect/reimu_huuin_hit_b.efk";
		}
	}
	public class MusoHuinGreenHitEffect : thrts.EffectParameter
	{
		public MusoHuinGreenHitEffect ()
		{
			EffectPath = "LotusCraft/3D/Effect/reimu_huuin_hit_g.efk";
		}
	}
	public class DaiKekkaiEffect : thrts.EffectParameter
	{
		public DaiKekkaiEffect ()
		{
			EffectPath = "LotusCraft/3D/Effect/reimu_kekkai_effect.efk";
		}
	}
	public class DaiKekkaiShotEffect : thrts.EffectParameter
	{
		public DaiKekkaiShotEffect ()
		{
			EffectPath = "LotusCraft/3D/Effect/reimu_kekkai_shot.efk";
		}
	}
	public class DaiKekkaiChargeEffect : thrts.EffectParameter
	{
		public DaiKekkaiChargeEffect ()
		{
			EffectPath = "LotusCraft/3D/Effect/reimu_kekkai_charge.efk";
		}
	}
}
