﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LotusCraft.Resource
{
	public class Type0 : thrts.ResourceParameter
	{
		public Type0()
		{
			Name = "清酒";
			Size = 2;
			ResourceType = 0;
			CollectPerOccurrence = 5;
			ObjectPath = "LotusCraft/3D/Model/Alchohole.mdl";
			HP = 3500;
			
		}
	}

	public class RichType0 : Type0
	{
		public RichType0()
		{
			Name = "大吟醸";
			Size = 2;
			ResourceType = 0;
			CollectPerOccurrence = 7;
			ObjectPath = "LotusCraft/3D/Model/Alchohole.mdl";
			HP = 2500;
		}
	}

	public class MuchType0 : Type0
	{
		public MuchType0()
		{
			Name = "伊吹瓢";
			Size = 2;
			ResourceType = 0;
			CollectPerOccurrence = 5;
			ObjectPath = "LotusCraft/3D/Model/Alchohole.mdl";
			HP = 6000;
		}
	}

	public class Type1 : thrts.ResourceParameter
	{
		public Type1()
		{
			Name = "霊石";
			Size = 2;
			ResourceType = 1;
			CollectPerOccurrence = 5;
			ObjectPath = "LotusCraft/3D/Model/PowerStone.mdl";
			HP = 3500;

			//ObjectEmissionColors = new Tuple<int, thrts.Color>[] { 
			//	new Tuple<int, thrts.Color>(0, new thrts.Color(0,0,1.0f, 0.0f))
			//};
		}

		public override void OnCreated(thrts.IResource resource)
		{
			resource.Drawing += () =>
				{
					resource.Object.SetUVOffset(0, new thrts.Vector2D(0, resource.World.CurrentTime / 270.0f));
				};
		}
	}

	public class RichType1 : Type1
	{
		public RichType1()
		{
			Name = "殺生石";
			Size = 2;
			ResourceType = 1;
			CollectPerOccurrence = 7;
			ObjectPath = "LotusCraft/3D/Model/PowerStoneYellow.mdl";
			HP = 2500;
		}
		
	}

	public class MuchType1 : Type1
	{
		public MuchType1()
		{
			Name = "高級霊石";
			Size = 2;
			ResourceType = 1;
			CollectPerOccurrence = 5;
			ObjectPath = "LotusCraft/3D/Model/PowerStone.mdl";
			HP = 5000;
		}

	}
}
