﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LotusCraft.Spell
{
	public class SpellLevelUp : thrts.SpellParameter<thrts.IUnit>
	{
		public SpellLevelUp(string faction)
		{
			DefaultLevel = 1;
			MaxLevel = 10;
			Name = thrts.SpellParameter<thrts.IUnit>.LevelHolderName;
			/// レベル別の能力説明無し
			EffectDescriptions = null;

			/// オートキャスト無し
			SpellAutoCasts = null;

			/// ボタンの位置
			ButtonPosX = thrts.ButtonPosition._4;
			ButtonPosY = thrts.ButtonPosition._2;

			/// スペルのレベルアップページ遷移ボタンを生成(3+3+3+1 = 10)
			SpellButtons = new thrts.ButtonParameter<thrts.IUnit>[]
			{
				new LotusCraft.Button.SpellPointButton(this,faction+"/Spell/LevelUp/0"),
				new LotusCraft.Button.SpellPointButton(this,faction+"/Spell/LevelUp/1"),
				new LotusCraft.Button.SpellPointButton(this,faction+"/Spell/LevelUp/2"),
				new LotusCraft.Button.SpellPointButton(this,faction+"/Spell/LevelUp/3"),
				new LotusCraft.Button.SpellPointButton(this,faction+"/Spell/LevelUp/4"),
				new LotusCraft.Button.SpellPointButton(this,faction+"/Spell/LevelUp/5"),
				new LotusCraft.Button.SpellPointButton(this,faction+"/Spell/LevelUp/6"),
				new LotusCraft.Button.SpellPointButton(this,faction+"/Spell/LevelUp/7"),
				new LotusCraft.Button.SpellPointButton(this,faction+"/Spell/LevelUp/8"),
				new LotusCraft.Button.SpellPointButton(this,faction+"/Spell/LevelUp/9"),
				new LotusCraft.Button.SpellPointButton(this,faction+"/Spell/LevelUp/10"),
			};
			/// レベルアップのレベルアップはないためキャンセルを設定
//			LevelUpSpellButton = new LotusCraft.Button.CancelLevelUpSpellButton(this, faction + "/Spell/LevelUp/0");
		}
	}
}
